function fxDTSBrick::onKeypadCorrect(%obj,%client) {
	$InputTarget_["Self"]	= %obj;
	$InputTarget_["Bot"]	= %obj.hBot;
	$InputTarget_["Player"] = %client.player;
	$InputTarget_["Client"] = %client;
	%obj.processInputEvent("onKeypadCorrect", %client);
}
function fxDTSBrick::onKeypadIncorrect(%obj,%client) {
	$InputTarget_["Self"]	= %obj;
	$InputTarget_["Bot"]	= %obj.hBot;
	$InputTarget_["Player"] = %client.player;
	$InputTarget_["Client"] = %client;
	%obj.processInputEvent("onKeypadIncorrect", %client);
}
function fxDTSBrick::onKeypadCancel(%obj,%client) {
	if(!$Pref::Server::Keypad::AllowonKeypadCancel) return;
	$InputTarget_["Self"]	= %obj;
	$InputTarget_["Bot"]	= %obj.hBot;
	$InputTarget_["Player"] = %client.player;
	$InputTarget_["Client"] = %client;
	%obj.processInputEvent("onKeypadCancel", %client);
}
function fxDTSBrick::sendKeypadRequest(%this,%codeType,%nan,%cl) {
	// %nan was %code, but is no longer used
	%code = %this.newKeypad_Password;
	if(strLen(%this.newKeypad_realPassword) != 4) {
		if(!isObject(%this.client)) return;
		messageClient(%this.client,'',"Brick "@%this@" ("@%this.getName()@") had a keypad init error: \"Code must be four characters in length.\"  The brick has had its raycasting disabled to prevent message spamming.");
		%this.setRayCasting(0);
		return;
	}
	for(%i=0;%i<strLen(%this.newKeypad_realPassword);%i++) {
		if(stripos("1234567890",getSubStr(%this.newKeypad_realPassword,%i,1)) == -1) {
			if(!isObject(%this.client)) return;
			messageClient(%this.client,'',"Brick "@%this@" ("@%this.getName()@") had a keypad init error: \"Code contains invalid characters.\" The brick has had its raycasting disabled to prevent message spamming.");
			%this.setRayCasting(0);
			return;
		}
	}
	%cl.sendKeypadRequest(%codeType,%code,%this.getID());
}
registerInputEvent("fxDTSBrick", "onKeypadCorrect", "Self fxDTSBrick" TAB "Bot Bot" TAB "Player Player" TAB "Client GameConnection");
registerInputEvent("fxDTSBrick", "onKeypadIncorrect", "Self fxDTSBrick" TAB "Bot Bot" TAB "Player Player" TAB "Client GameConnection");
registerInputEvent("fxDTSBrick", "onKeypadCancel", "Self fxDTSBrick" TAB "Bot Bot" TAB "Player Player" TAB "Client GameConnection");
registerOutputEvent("fxDTSBrick","sendKeypadRequest", "list Keypad 2 Combo 3	string 4 100", 1);
